angular.module('app.controllers', [])

.controller('saldoCtrl', ['$scope', '$stateParams', '$http', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http) {
  $scope.loaded = 0;

  $scope.userData = {
    balance: '0,00'
  }

  $scope.qrimg = "";

  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/user',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    console.log('user: ' + JSON.stringify(data));
    $scope.userData = data.data;
    $scope.loaded = 1;
    $scope.$digest();
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });

  var qr = new QRious({
    element: document.querySelector('canvas'),
    value: localStorage.getItem("wristband"),
    size: 500
  });

  $scope.qrimg = qr.toDataURL();

  $scope.history = {}

  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/user/transactions',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    console.log('user: ' + JSON.stringify(data));
    $scope.history = data.data;
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });


}])

.controller('aktiviteterCtrl', ['$scope', '$stateParams', '$http', '$filter', '$rootScope', '$state', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $filter, $rootScope, $state) {

  $scope.activities = {};
  $scope.filteredActivities = {
    "Søndag": [],
    "Mandag": [],
    "Tirsdag": [],
    "Onsdag": [],
    "Torsdag": [],
    "Fredag": [],
    "Lørdag": []
  };

  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/activities/mine',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){

    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    //console.log('user: ' + JSON.stringify(data));
    $scope.activities = data.data;
    angular.forEach(data.data, function(value, key) {
      console.log('dag' + key);
      //key = key.split(".");
      //key = key[2] + '-' + key[1] + '-' + key[0];
      console.log('dag' + key);
      key = $filter('date')(key, "EEEE");
      console.log('dag: ' + key);
      switch (key) {
        case "Monday":
            key = "Mandag";
            break;
        case "Tuesday":
            key = "Tirsdag";
            break;
        case "Wednesday":
            key = "Onsdag";
            break;
        case "Thursday":
            key = "Torsdag";
            break;
        case "Friday":
            key = "Fredag";
            break;
        case "Saturday":
            key = "Lørdag";
            break;
        case "Sunday":
            key = "Søndag";
    }

      $scope.filteredActivities[key] = [];
      angular.forEach(value, function(okt, oktkey) {
        console.log(okt);

        okt.start = okt.start.substring(0, 5);
        okt.stop = okt.stop.substring(0, 5);

        $scope.filteredActivities[key].push({
          'startSort': okt.start.replace(':', ''),
          'start': okt.start,
          'end': okt.stop,
          'name': okt.name,
          'type': okt.type,
          //'instructorname': activity.instructor.name,
          ///'instructorphone': activity.instructor.phone,
          'description': okt.description
        });

        /*
        angular.forEach(okt.activities, function(activity, activitykey) {
                    angular.forEach(activity.times, function(times, timeskey) {
                      $scope.filteredActivities[key].push({
                        'startSort': times.start.replace(':', ''),
                        'start': times.start,
                        'end': times.end,
                        'name': activity.name,
                        'instructorname': activity.instructor.name,
                        'instructorphone': activity.instructor.phone,
                        'description': activity.description
                      });
                    });
        });
        */
      });
    });
    $scope.filteredActivities = JSON.parse(JSON.stringify($scope.filteredActivities), true);
    console.log('filtered: ' + JSON.stringify($scope.filteredActivities));
    $scope.$digest();
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });

  $scope.goToActivity = function(data) {
    $rootScope.activityData = data;
    $state.go('tabsController.aktivitet');
  }

}])

.controller('aktivitetCtrl', ['$scope', '$stateParams', '$rootScope', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $rootScope) {
$scope.data = $rootScope.activityData;

}])

.controller('historikkCtrl', ['$scope', '$stateParams', '$http', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http) {
  $scope.loaded = 0;
  $scope.userinfoscanned = {};

  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/user',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    console.log('user: ' + JSON.stringify(data));
    $scope.userinfoscanned = data.data;
    $scope.loaded = 1;
    $scope.digest();
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });


}])

.controller('loginCtrl', ['$scope', '$stateParams', '$http', '$state', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $ionicPopup) {

  $scope.inUpdate = 0;
  $scope.updateProgress = 0;

$scope.$on('$ionicView.enter', function() {
   /*if(localStorage.getItem("token") != null && localStorage.getItem("wristband") != null) {
     $state.go('tabsController.saldo');
   }*/
})

$scope.code = 0;
$scope.credentials = {
  'mobile': '',
  'password': ''
};

$scope.stage = 1;

$scope.scan = function() {
  cordova.plugins.barcodeScanner.scan(
      function (result) {
          //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
          $scope.code = result.text;

          if($scope.code != "") {
              $scope.login();
          }
      },
      function (error) {
          alert("Scanning failed: " + error);
      },
      {
          preferFrontCamera : false, // iOS and Android
          showFlipCameraButton : false, // iOS and Android
          showTorchButton : true, // iOS and Android
          torchOn: true, // Android, launch with the torch switched on (if available)
          prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
          resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
          formats : "CODE_39", // default: all but PDF_417 and RSS_EXPANDED
          orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
          disableAnimations : true, // iOS
          disableSuccessBeep: false // iOS
      }
   );
}

$scope.toggleInstructor = function() {
  if($scope.stage == 1) {
    $scope.stage = 2;
  } else {
    $scope.stage = 1;
  }
}

$scope.demo = function(){
  $scope.code = "5901234123457"
  $scope.login();
}

$scope.login = function() {
  console.log($scope.credentials.password);
  var req = {
   method: 'POST',
   url: 'https://leir.vixo.no/login',
   headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'},
   data: 'type=user&wristband='+$scope.code+'&api_token=oyah2Yineengoo8E'
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/

    if(data.data.code == "wristband_invalid") {
      $ionicPopup.alert({
         title: 'Feil!',
         template: "Kunne ikke logge på, vennligst kontakt en innstruktør."
       });
    } else {
      localStorage.setItem('token', data.data.token);
      localStorage.setItem('wristband', $scope.code);

      $state.go('tabsController.aktiviteter');
    }
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });
}

$scope.loginInstructor = function() {
  console.log($scope.credentials.password);
  var req = {
   method: 'POST',
   url: 'https://leir.vixo.no/login',
   headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'},
   data: 'type=instructor&phone='+$scope.credentials.mobile+'&password='+$scope.credentials.password+'&api_token=oyah2Yineengoo8E'
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    localStorage.setItem('token', data.data.token);

    //alert(JSON.stringify(data));

    if(data.data.token != null) {
      //alert("login");
      localStorage.setItem('token', data.data.token);
      $state.go('instructorTabs.dashboard');
    } else {
      $ionicPopup.alert({
         title: 'Feil!',
         template: "Kunne ikke logge på, vennligst sjekk telefonnummer eller passord."
       });
    }
    //$state.go('tabsController.saldo');
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });
}

}])


.controller('instructorCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$ionicModal', '$timeout', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $ionicModal, $timeout) {

  $scope.instructorInfo = {
    'bank_access': false
  };

  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/users',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    $rootScope.userlist = data;
    $scope.userlists = data;
    console.log("users added");
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });


  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/locations',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    $rootScope.locations = data;
    $scope.locations = data;
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });


  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/user',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    /*console.log('user: ' + JSON.stringify(data));
    $scope.$evalAsync(function() {
      $scope.instructorInfo = data.data;
      console.log($scope.instructorInfo);
    });*/

    $timeout(function () {
      $scope.instructorInfo = data.data;
      console.log('access: ' + $scope.instructorInfo.bank_access);
    }, 0);

    $scope.$apply(function () {
      $scope.instructorInfo = data.data;
      console.log('access: ' + $scope.instructorInfo.bank_access);
    });
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });


  $scope.userinfoscanned;

  $ionicModal.fromTemplateUrl('templates/userinfomodal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.scaninfo = function() {
    cordova.plugins.barcodeScanner.scan(
        function (result) {
            //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
            //$scope.data.code = result.text;

            if(result.text != "") {
              var req = {
               method: 'GET',
               url: 'https://leir.vixo.no/wristband/' + result.text,
               headers: {
                 'token': localStorage.getItem('token')
               },
              }

              $http(req).then(function(data){
                console.log('1: ' + JSON.stringify(data));
                //console.log('token: ' + data.data.token);
                if(data.data.code == "wristband_invalid") {
                  $ionicPopup.alert({
                     title: 'Feil!',
                     template: data.data.desc_no
                   });
                } else {
                  $scope.userinfoscanned = data.data;
                }
              }, function(data){
                console.log('2: ' + JSON.stringify(data));
              });

              $scope.modal.show();
          }
        },
        function (error) {
            alert("Scanning failed: " + error);
        },
        {
            preferFrontCamera : false, // iOS and Android
            showFlipCameraButton : false, // iOS and Android
            showTorchButton : true, // iOS and Android
            torchOn: true, // Android, launch with the torch switched on (if available)
            prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
            resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats : "CODE_39,QR", // default: all but PDF_417 and RSS_EXPANDED
            orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations : true, // iOS
            disableSuccessBeep: false // iOS
        }
     );
  }


}])

.controller('instructorsjekkinnCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $ionicPopup) {
$scope.userlists = $rootScope.userlist;

$scope.innsjekk = {
  'person': '',
  'tent': '',
  'place': '',
  'wristband': ''
}

$scope.searchStr = '';

$scope.scan = function() {
  cordova.plugins.barcodeScanner.scan(
      function (result) {
          //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
          $scope.innsjekk.wristband = result.text;
          $scope.$digest();

      },
      function (error) {
          alert("Scanning failed: " + error);
      },
      {
          preferFrontCamera : false, // iOS and Android
          showFlipCameraButton : false, // iOS and Android
          showTorchButton : true, // iOS and Android
          torchOn: true, // Android, launch with the torch switched on (if available)
          prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
          resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
          formats : "CODE_39,QR", // default: all but PDF_417 and RSS_EXPANDED
          orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
          disableAnimations : true, // iOS
          disableSuccessBeep: false // iOS
      }
   );

}


$scope.sjekkinn = function() {
  console.log($scope.innsjekk.person);

var req = {
 method: 'POST',
 url: 'https://leir.vixo.no/users/checkin',
 headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8', 'token': localStorage.getItem('token')},
 /*data: {
   'userID': $scope.innsjekk.person.originalObject.id,
   'wristband': $scope.innsjekk.wristband,
   'tent': $scope.innsjekk.tent,
   'space': $scope.innsjekk.place,
   'firstname': $scope.innsjekk.person.originalObject.firstname,
   'surname': $scope.innsjekk.person.originalObject.surname,
   'phone': $scope.innsjekk.person.originalObject.phone,
   'swimming': $scope.innsjekk.person.originalObject.swimming,
   'special': $scope.innsjekk.person.originalObject.special,
   'years': $scope.innsjekk.person.originalObject.years,
   'allergies': $scope.innsjekk.person.originalObject.allergies,
   'note': $scope.innsjekk.person.originalObject.note,
   'guardian_firstname': $scope.innsjekk.person.originalObject.guardian.firstname,
   'guardian_surname': $scope.innsjekk.person.originalObject.guardian.surname,
   'guardian_email': $scope.innsjekk.person.originalObject.guardian.email,
   'guardian_phone': $scope.innsjekk.person.originalObject.guardian.phone,
   'birthday': $scope.innsjekk.person.originalObject.birthday,
   'address': $scope.innsjekk.person.originalObject.address,
   'zipcode': $scope.innsjekk.person.originalObject.zipcode,
   'municipality': $scope.innsjekk.person.originalObject.municipality
 }*/

 data:
  'userID='+$scope.innsjekk.person.originalObject.id
   +'&wristband=' + $scope.innsjekk.wristband
   +'&tent='+$scope.innsjekk.tent
   +'&space='+$scope.innsjekk.place
   +'&firstname='+$scope.innsjekk.person.originalObject.firstname
   +'&surname='+$scope.innsjekk.person.originalObject.surname
   +'&phone='+$scope.innsjekk.person.originalObject.phone
   +'&swimming='+$scope.innsjekk.person.originalObject.swimming
   +'&special='+$scope.innsjekk.person.originalObject.special
   +'&years='+$scope.innsjekk.person.originalObject.years
   +'&allergies='+$scope.innsjekk.person.originalObject.allergies
   +'&note='+$scope.innsjekk.person.originalObject.note
   +'&guardian_firstname='+$scope.innsjekk.person.originalObject.guardian.firstname
   +'&guardian_surname='+$scope.innsjekk.person.originalObject.guardian.surname
   +'&guardian_email='+$scope.innsjekk.person.originalObject.guardian.email
   +'&guardian_phone='+$scope.innsjekk.person.originalObject.guardian.phone
   +'&birthday='+$scope.innsjekk.person.originalObject.birthday
   +'&address='+$scope.innsjekk.person.originalObject.address
   +'&zipcode='+$scope.innsjekk.person.originalObject.zipcode
   +'&municipality='+$scope.innsjekk.person.originalObject.municipality
}

$http(req).then(function(data){
  //alert(JSON.stringify(data));
  if(data.data.success != null) {

    $ionicPopup.alert({
       title: 'Fullført!',
       template: 'Deltakeren ble sjekket inn.'
     });

    $scope.innsjekk.person = '';
    $scope.innsjekk.wristband = '';
    $scope.innsjekk.place = '';
    $scope.innsjekk.tent = '';
    $scope.$broadcast('angucomplete-alt:clearInput');
  } else {
    //alert(data.data.desc_no);
    $ionicPopup.alert({
       title: 'Feil!',
       template: data.data.desc_no
     });
  }
}, function(data){
  $ionicPopup.alert({
     title: 'Feil!',
     template: 'Prøv igjen.'
   });
});

}

}])

.controller('instructorsearchuserinfoCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$filter', '$ionicModal', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $filter, $ionicModal) {

$scope.userlists = $rootScope.userlist;
$scope.userinfoscanned = {
  'person': ''
};

$scope.showActivities = false;

$scope.activities = {};

$scope.filteredActivities = [];
$scope.activityData = [];


  $ionicModal.fromTemplateUrl('activitymodal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) { $scope.modal = modal; });

$scope.showUserinfoBoolean = function() {
  if($scope.activities.length == 0) {
    return false;
  }

  if($scope.filteredActivities.length != 0 && $scope.showActivities == true) {
    return false;
  }

  if($scope.filteredActivities.length != 0 && $scope.showActivities == true) {
    return true;
  }
}

$scope.goToActivity = function(data) {
  $scope.activityData = data;
  $scope.modal.show();
}

$scope.viewUserinfo = function() {
  $scope.showActivities = false;
}

$scope.viewActivities = function() {
  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/activities/user/' + $scope.userinfoscanned.person.originalObject.id,
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    $scope.showActivities = true;

    $scope.activities = data.data;
    angular.forEach(data.data, function(value, key) {
      //console.log('dag' + key);
      //key = key.split(".");
      //key = key[2] + '-' + key[1] + '-' + key[0];
      //console.log('dag' + key);
      key = $filter('date')(key, "EEEE");
      console.log('dag: ' + key);
      switch (key) {
        case "Monday":
            key = "Mandag";
            break;
        case "Tuesday":
            key = "Tirsdag";
            break;
        case "Wednesday":
            key = "Onsdag";
            break;
        case "Thursday":
            key = "Torsdag";
            break;
        case "Friday":
            key = "Fredag";
            break;
        case "Saturday":
            key = "Lørdag";
            break;
        case "Sunday":
            key = "Søndag";
    }

      $scope.filteredActivities[key] = [];
      angular.forEach(value, function(okt, oktkey) {
        //console.log("okt" + oktkey);

        okt.start = okt.start.substring(0, 5);
        okt.stop = okt.stop.substring(0, 5);

        $scope.filteredActivities[key].push({
          'startSort': okt.start.replace(':', ''),
          'start': okt.start,
          'end': okt.stop,
          'name': okt.name,
          'type': okt.type,
          'instructor': okt.instructor,
          //'instructorname': activity.instructor.name,
          ///'instructorphone': activity.instructor.phone,
          'description': okt.description
        });
      });
    });
    $scope.filteredActivities = JSON.parse(JSON.stringify($scope.filteredActivities), true);
    console.log($scope.filteredActivities);
    $scope.$digest();
  });
}

$scope.log = function() {
  console.log($scope.userinfoscanned.person);
}

}])

.controller('locationCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $ionicPopup) {
$scope.userlists = $rootScope.userlist;
$scope.locations = $rootScope.locations.data;
console.log(JSON.stringify($scope.locations));
$scope.userinfoscanned = {
  'person': ''
};

$scope.locationdata = {
  'location': 0
}


$scope.SaveLocation = function() {
  var req = {
   method: 'POST',
   url: 'https://leir.vixo.no/locations',
   headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8', 'token': localStorage.getItem('token')},
   data: 'userID='+$scope.userinfoscanned.person.originalObject.id+'&locationID='+$scope.locationdata.location
  }

  $http(req).then(function(data){
if(data.data.success != null) {
    $ionicPopup.alert({
       title: 'Utført!',
       template: 'Din handling er nå utført!'
     });
     $scope.locationdata.location = 0;
     $scope.$broadcast('angucomplete-alt:clearInput');
   } else {
     $ionicPopup.alert({
        title: 'Feil!',
        template: 'Noe galt har skjedd, prøv igjen!'
      });
   }
  });
}



}])

.controller('moneyCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $ionicPopup) {

  $scope.data = {
    'code': '',
    'money': '',
    'description': 'Legg til penger'
  }

  $scope.currentUser = {
    'user': {
      'firstname': '',
      'surname': '',
      'balance': 0
    }
  };

  $scope.scan = function() {
    cordova.plugins.barcodeScanner.scan(
        function (result) {
            //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
            $scope.data.code = result.text;

            var req = {
             method: 'GET',
             url: 'https://leir.vixo.no/wristband/' + result.text,
             headers: {
               'token': localStorage.getItem('token')
             },
            }

            $http(req).then(function(data){
              console.log('1: ' + JSON.stringify(data));
              if(data.data.code == "wristband_invalid") {
                $ionicPopup.alert({
                   title: 'Feil!',
                   template: data.data.desc_no
                 });
              } else {
                $scope.currentUser = data.data;
              }
            }, function(data){
              console.log('2: ' + JSON.stringify(data));
            });

        },
        function (error) {
            alert("Scanning failed: " + error);
        },
        {
            preferFrontCamera : false, // iOS and Android
            showFlipCameraButton : false, // iOS and Android
            showTorchButton : true, // iOS and Android
            torchOn: true, // Android, launch with the torch switched on (if available)
            prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
            resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats : "CODE_39,QR", // default: all but PDF_417 and RSS_EXPANDED
            orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations : true, // iOS
            disableSuccessBeep: false // iOS
        }
     );

  }

  $scope.SendMoneyCall = function(action) {
    if($scope.data.description == '') {
      $scope.data.description = 'Legg til Penger.';
    }

    if(action == "remove") {
      $scope.data.money = "-" + $scope.data.money;
    }

    var req = {
     method: 'POST',
     url: 'https://leir.vixo.no/user/transactions',
     headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8', 'token': localStorage.getItem('token')},
     data: 'wristband='+$scope.data.code+'&amount='+$scope.data.money+'&description='+$scope.data.description
    }

    $http(req).then(function(data){
      //alert(JSON.stringify(data));
      console.log(JSON.stringify(data));
      if(data.data.success != null) {

        $scope.data = {
          'code': '',
          'money': '',
          'description': ''
        }

        $scope.currentUser = {
          'user': {
            'firstname': '',
            'surname': '',
            'balance': 0
          }
        };

        $ionicPopup.alert({
           title: 'Utført!',
           template: 'Din handling er nå utført!'
         });
      } else {
        $ionicPopup.alert({
           title: 'Feil!',
           template: data.data.desc_no
         });
      }
    }, function(data){
      $ionicPopup.alert({
         title: 'Feil!',
         template: 'Feil prøv igjen!'
       });
    });
  }


  $scope.AddMoney = function() {
    $scope.SendMoneyCall('');
  }

  $scope.RemoveMoney = function() {
    $scope.SendMoneyCall('remove');
  }

}])

.controller('moneytakeCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $ionicPopup) {

  $scope.data = {
    'code': '',
    'money': '',
    'description': 'Slushkiosk'
  }

  $scope.currentUser = {
    'user': {
      'firstname': '',
      'surname': '',
      'balance': 0
    }
  };

  $scope.scan = function() {
    cordova.plugins.barcodeScanner.scan(
        function (result) {
            //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
            $scope.data.code = result.text;

            var req = {
             method: 'GET',
             url: 'https://leir.vixo.no/wristband/' + result.text,
             headers: {
               'token': localStorage.getItem('token')
             },
            }

            $http(req).then(function(data){
              console.log('1: ' + JSON.stringify(data));
              if(data.data.code == "wristband_invalid") {
                $ionicPopup.alert({
                   title: 'Feil!',
                   template: data.data.desc_no
                 });
              } else {
                $scope.currentUser = data.data;
              }
            }, function(data){
              console.log('2: ' + JSON.stringify(data));
            });

        },
        function (error) {
            alert("Scanning failed: " + error);
        },
        {
            preferFrontCamera : false, // iOS and Android
            showFlipCameraButton : false, // iOS and Android
            showTorchButton : true, // iOS and Android
            torchOn: true, // Android, launch with the torch switched on (if available)
            prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
            resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats : "CODE_39,QR", // default: all but PDF_417 and RSS_EXPANDED
            orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations : true, // iOS
            disableSuccessBeep: false // iOS
        }
     );

  }

  $scope.SendMoneyCall = function(action) {
    if($scope.data.description == '') {
      $scope.data.description = 'Slushkiosk';
    }

    if(action == "remove") {
      $scope.data.money = "-" + $scope.data.money;
    }

    var req = {
     method: 'POST',
     url: 'https://leir.vixo.no/user/transactions',
     headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8', 'token': localStorage.getItem('token')},
     data: 'wristband='+$scope.data.code+'&amount='+$scope.data.money+'&description='+$scope.data.description
    }

    $http(req).then(function(data){
      //alert(JSON.stringify(data));
      console.log(JSON.stringify(data));
      if(data.data.success != null) {

        $ionicPopup.alert({
           title: 'Utført!',
           template: 'Din handling er nå utført! Kunden ble trukket ' + $scope.data.money
         });

         $scope.data = {
           'code': '',
           'money': '',
           'description': ''
         }

         $scope.currentUser = {
           'user': {
             'firstname': '',
             'surname': '',
             'balance': 0
           }
         };

      } else {
        $ionicPopup.alert({
           title: 'Feil!',
           template: data.data.desc_no
         });
      }
    }, function(data){
      $ionicPopup.alert({
         title: 'Feil!',
         template: 'Feil prøv igjen!'
       });
    });
  }


  $scope.AddMoney = function() {
    $scope.SendMoneyCall('');
  }

  $scope.RemoveMoney = function() {
    $scope.SendMoneyCall('remove');
  }

}])


.controller('changeWristbandCtrl', ['$scope', '$stateParams', '$http', '$state', '$rootScope', '$ionicPopup', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $state, $rootScope, $ionicPopup) {

  $scope.userlists = $rootScope.userlist;

  $scope.data = {
    'code': '',
    'person': ''
  }

  $scope.scan = function() {
    cordova.plugins.barcodeScanner.scan(
        function (result) {
            //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);
            $scope.data.code = result.text;
            $scope.$digest();
        },
        function (error) {
            $ionicPopup.alert({
               title: 'Feil!',
               template: 'Oops! ' + error
             });
        },
        {
            preferFrontCamera : false, // iOS and Android
            showFlipCameraButton : false, // iOS and Android
            showTorchButton : true, // iOS and Android
            torchOn: true, // Android, launch with the torch switched on (if available)
            prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
            resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
            formats : "CODE_39,QR", // default: all but PDF_417 and RSS_EXPANDED
            orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
            disableAnimations : true, // iOS
            disableSuccessBeep: false // iOS
        }
     );

  }

  $scope.change = function() {
    var req = {
     method: 'POST',
     url: 'https://leir.vixo.no/users/wristband',
     headers: {'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8', 'token': localStorage.getItem('token')},
     data: 'wristband='+$scope.data.code+'&userID='+$scope.data.person.originalObject.id
    }

    $http(req).then(function(data){
      //alert(JSON.stringify(data));
      console.log(JSON.stringify(data));
      if(data.data.success != null) {
        $scope.data = {
          'code': '',
          'person': ''
        }
        $ionicPopup.alert({
           title: 'Fullført!',
           template: 'Handling ble utført!'
         });
      } else {
        $ionicPopup.alert({
           title: 'Feil!',
           template: data.data.desc_no
         });
      }
    }, function(data){
      $ionicPopup.alert({
         title: 'Feil!',
         template: 'Feil prøv igjen'
       });
    });
  }

}])

.controller('instructorActivitiesCtrl', ['$scope', '$stateParams', '$http', '$filter', '$rootScope', '$state', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $filter, $rootScope, $state) {
  $scope.activities = {};
  $scope.filteredActivities = {};

  $rootScope.showAll = false;

  var req = {
   method: 'GET',
   url: 'https://leir.vixo.no/activities',
   headers: {
     'token': localStorage.getItem('token')
   },
  }

  $http(req).then(function(data){
    /*console.log('1: ' + JSON.stringify(data));
    console.log('token: ' + data.data.token);*/
    //console.log('user: ' + JSON.stringify(data));
    $scope.activities = data.data;
    angular.forEach(data.data, function(value, key) {
      console.log('dag' + key);
      //key = key.split(".");
      //key = key[2] + '-' + key[1] + '-' + key[0];
      console.log('dag' + key);
      key = $filter('date')(key, "EEEE");
      console.log('dag: ' + key);
      switch (key) {
        case "Monday":
            key = "Mandag";
            break;
        case "Tuesday":
            key = "Tirsdag";
            break;
        case "Wednesday":
            key = "Onsdag";
            break;
        case "Thursday":
            key = "Torsdag";
            break;
        case "Friday":
            key = "Fredag";
            break;
        case "Saturday":
            key = "Lørdag";
            break;
        case "Sunday":
            key = "Søndag";
    }

      $scope.filteredActivities[key] = [];
      angular.forEach(value, function(okt, oktkey) {
        console.log("okt" + oktkey);

        okt.start = okt.start.substring(0, 5);
        okt.stop = okt.stop.substring(0, 5);

        $scope.filteredActivities[key].push({
          'startSort': okt.start.replace(':', ''),
          'start': okt.start,
          'end': okt.stop,
          'name': okt.name,
          'type': okt.type,
          'instructor': okt.instructor,
          //'instructorname': activity.instructor.name,
          ///'instructorphone': activity.instructor.phone,
          'description': okt.description
        });


        /*
        angular.forEach(okt.activities, function(activity, activitykey) {
          angular.forEach(activity.times, function(times, timeskey) {
            $scope.filteredActivities[key].push({
              'startSort': times.start.replace(':', ''),
              'start': times.start,
              'end': times.stop,
              'name': activity.name,
              'description': activity.description,
              'participants': activity.participants
            });
          });
        });
        */
      });
    });
    $scope.filteredActivities = JSON.parse(JSON.stringify($scope.filteredActivities), true);
    console.log('filtered: ' + JSON.stringify($scope.filteredActivities));
    $scope.$digest();
  }, function(data){
    console.log('2: ' + JSON.stringify(data));
  });

  $scope.goToActivity = function(data) {
    $rootScope.activityData = data;
    $state.go('instructorTabs.aktivitet');
  }

}])

.controller('instructoraktivitetCtrl', ['$scope', '$stateParams', '$rootScope', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $rootScope) {
$scope.data = $rootScope.activityData;
console.log(JSON.stringify($scope.data));

}])

.controller('userinfoCtrl', ['$scope', '$stateParams', '$http', '$filter', '$rootScope', '$state', // The following is the constructor function for this page's controller. See https://docs.angularjs.org/guide/controller
// You can include any angular dependencies as parameters for this function
// TIP: Access Route Parameters for your page via $stateParams.parameterName
function ($scope, $stateParams, $http, $filter, $rootScope, $state) {
$scope.userlists = $rootScope.userlist;



$scope.scan = function() {
  cordova.plugins.barcodeScanner.scan(
      function (result) {
          //alert("We got a barcode\n" + "Result: " + result.text + "\n" + "Format: " + result.format + "\n" + "Cancelled: " + result.cancelled);

          $scope.code = result.text;
          $scope.login();
      },
      function (error) {
          alert("Scanning failed: " + error);
      },
      {
          preferFrontCamera : false, // iOS and Android
          showFlipCameraButton : false, // iOS and Android
          showTorchButton : true, // iOS and Android
          torchOn: true, // Android, launch with the torch switched on (if available)
          prompt : "Plasser strekkoden under kameraet, og ikke flytt telefonen.", // Android
          resultDisplayDuration: 500, // Android, display scanned text for X ms. 0 suppresses it entirely, default 1500
          formats : "CODE_39,QR", // default: all but PDF_417 and RSS_EXPANDED
          orientation : "landscape", // Android only (portrait|landscape), default unset so it rotates with the device
          disableAnimations : true, // iOS
          disableSuccessBeep: false // iOS
      }
   );
}

}])
